/* files */
#define CONFIG_BUILD "6335i"
#ifndef CONFIG_BUILD
# define CONFIG_BUILD BUILD
#endif
#ifdef RC_DIR
#undef RC_DIR
#endif
#define RC_DIR "rfm" 
#define TAG "" 

////////////////////////////   Configuration files   /////////////////////////////////
//
#define GLIB_WAY
#ifdef GLIB_WAY
#define USER_DIR 		g_get_home_dir()
#define USER_CACHE_DIR		g_get_user_cache_dir()
#define USER_CONFIG_DIR		g_get_user_config_dir()
// This is now deprectated, data is also config data for rfm:
#define USER_DATA_DIR		USER_CONFIG_DIR
#else
#define USER_DIR 		getenv("HOME")
#define USER_CACHE_DIR		USER_DIR,".cache"
#define USER_CONFIG_DIR		USER_DIR,".config"
#define USER_DATA_DIR		USER_CONFIG_DIR

#endif
//
// Environment configuration file (shared via MIT-shm)
#define MCS_FILE_NAME		"rfm-"CONFIG_BUILD
#define MCS_SHM_PLUGIN_FILE 	USER_CONFIG_DIR,RC_DIR,MCS_FILE_NAME

// Keybind customization file	
#define KEYBINDINGS_FILE 	USER_CONFIG_DIR,RC_DIR,"keybind-6224.xml"
#define KEYBINDINGS_SCHEMA 	PACKAGE_DATA_DIR,"rfm","modules","keybind.xsd"

//############################################
//   dbh files and associated record structure
//############################################
/**************************************************************/
/////////////////////  history_dbh_t /////////////////////////
/**************************************************************/
// This structure could be optimized to a token separated string
// 
typedef struct history_dbh_t {
    gint64 hits;  // 32/64 issue: gint
    gint64 last_hit; // time_t last_hit;
    gchar path[256];
} history_dbh_t;
// Goto dialog history
#define GOTO_DBH_FILE 		USER_DATA_DIR,"rfm","dbh","go_hash.dbh"
// Run dialog history
#define RUN_DBH_FILE 		USER_DATA_DIR,"rfm","dbh","run_hash.dbh"
// Workdir dialog history
#define WORKDIR_DBH_FILE 	USER_DATA_DIR,"rfm","dbh","workdir_hash.dbh"
// Fgr module history autocompletion
#define FIND_DBH_FILE 		USER_DATA_DIR,"rfm","dbh","fgr_path_hash.dbh"
#define FIND_PATHS_DBH_FILE 	USER_DATA_DIR,"rfm","dbh","fgr_filter_hash.dbh"
#define FIND_GREP_DBH_FILE 	USER_DATA_DIR,"rfm","dbh","fgr_content_hash.dbh"
// ...
#define LS_DBH_FILE	 	USER_DATA_DIR,"rfm","dbh","ls_path_hash.dbh"
// Callbacks mount point dialog files
#define MOUNT_DBH_FILE 		USER_DATA_DIR,"rfm","dbh","mountdir_hash.dbh"


// dbh preferences (Not environment)
/**************************************************************/
/////////////////////  view_geometry_t /////////////////////////
/**************************************************************/
typedef struct view_geometry_t {
    gint64 scrollX;
    gint64 x;
    gint64 y;
    gint64 w;
    gint64 h;
} view_geometry_t;
#define GRID_GEOMETRY_FILE 	USER_CONFIG_DIR,"rfm","dbh","geometry64.dbh"
#define DESK_GEOMETRY_FILE 	USER_CONFIG_DIR,"rfm","dbh","deskview_geometry64.dbh"

/**************************************************************/
/////////////////////  view_preferences_t //////////////////////
/**************************************************************/
typedef struct view_preferences_t {
    gint64 preferences;
    gint64 sortcolumn;
    gint64 icon_size;
} view_preferences_t;
#define GRID_PREFERENCES_FILE 	USER_CONFIG_DIR,"rfm","dbh","preferences64.dbh"
#define DESK_PREFERENCES_FILE 	USER_CONFIG_DIR,"rfm","dbh","preferences-desk64.dbh"

/**************************************************************/
/////////////////////   //////////////////////
/**************************************************************/
// Run dialog flags
// gint64 flags[2]
#define RUN_FLAG_FILE 		USER_DATA_DIR,"rfm","dbh","runflag64.dbh"

/**************************************************************/
/////////////////////   //////////////////////
/**************************************************************/
// User defined mount types (local or monitor) in fstab plugin
// gint64 type
#define MOUNT_TYPE_DBH_FILE	USER_DATA_DIR,"rfm","dbh","mounttype64.dbh"

/**************************************************************/
/////////////////////  caches //////////////////////
/**************************************************************/
typedef struct  mime_winner_dbh_t {
    gint64 st_sum;
    gchar mimetype[80];
} mime_winner_dbh_t;
#define MIME_COUNT_DBH_FILE 	USER_CACHE_DIR,"rfm","dbh","mimecount64.dbh"
// string hash
#define ICON_ID_DBH_FILE 	USER_CACHE_DIR,"rfm","dbh","icon_id64.dbh"
#define ICON_ID_PLAIN_DBH_FILE 	USER_CACHE_DIR,"rfm","dbh","icon_id_plain64.dbh"


//
////////////////////////////   Cache files   /////////////////////////////////////////
// General cache directory
#define SETUP_FILE 		USER_DATA_DIR,RC_DIR,"rodent-"BUILD
#define RFM_CACHE_DIR 		USER_CACHE_DIR,RC_DIR,"cache"
// Specific cache directory for thumbnails
// Here we use MCS_FILE_NAME to have a new thumbnail cache for
// each build specific configuration. Xffm < 4.9.3 did not work around
// a gdkpixbuf bug with .xpm files which were not scaled correctly
// on initial load. Using a different thumbnail cache directory 
// garantees that incorrect pixbufs for xpm applications shall not
// be honored.
#define RFM_THUMBNAIL_DIR 	USER_CACHE_DIR,MCS_FILE_NAME,"thumbnails"
// DBH cache file for content emblems
//
////////////////////////////   Data files   /////////////////////////////////////////
//
// Dialogs...
// Lp terminal history cache
#define LP_TERMINAL_HISTORY 	USER_DATA_DIR,RC_DIR,"lp_terminal_history"
// Modules...
// Icon module xml files
#define ICON_MODULE_USER_XML	USER_DATA_DIR,"rfm","modules","icons.mime.xml"
#define ICON_MODULE_XML		PACKAGE_DATA_DIR, "rfm","modules", "icons.mime.xml"
#define USER_PIXMAPS		USER_DATA_DIR, "pixmaps"
#define RODENT_THEME		PACKAGE_DATA_DIR,"icons","Rodent"
// Mime module files
#define APPLICATION_MIME_FILE 	PACKAGE_DATA_DIR,"rfm","modules","mime-module.xml"
#define USER_APPLICATIONS 	USER_DATA_DIR,"rfm","modules","user-applications.2"
#define MOUNT_HISTORY_FILE 	USER_DATA_DIR,"rfm","modules","mountdir.txt"
// Plugins...
// Fuse plugin keyfile
#define FUSE_KEY_FILE		USER_DATA_DIR,"rfm","plugins","fuse.ini"
// Bookmarks file (default gtk site)
#define BOOKMARKS_FILE		USER_DIR,".gtk-bookmarks"
// Mimetype files 
#define FREEDESKTOP_MIME_FILE 	PACKAGE_DATA_DIR,RC_DIR,"freedesktop.org.xml"
#define MAGIC_MIME_FILE 	PACKAGE_DATA_DIR,RC_DIR,"types.xml"
//
////////////////////////////   General files   ///////////////////////////////////////
// Default desktop directory
#define DEFAULT_DESKTOP_DIR	USER_DIR,_("Desktop")


